//
//
//

#ifndef AMT_ASSERT_H_
#define AMT_ASSERT_H_

#include <amt/Exception.h>

namespace AMT
{

namespace Assert
{

void assert_(const char *, const char *, const char *, int, const char *);

namespace Domain { }

}

}

#ifdef AMT_DEBUG
#define AMT_ASSERT_(domain, comm, cond, strcond)			      \
do {									      \
	if ((cond))							      \
		;							      \
	else								      \
		AMT::Assert::assert_(AMT::Assert::Domain::domain(),	      \
				     (comm),				      \
				     __FILE__, __LINE__, strcond);	      \
} while (/*CONSTCOND*/0)
#else
#define AMT_ASSERT_(domain, comm, cond, strcond)
#endif

#define AMT_ASSERT(domain, comm, cond)					      \
AMT_ASSERT_(domain, comm, cond, #cond)

#define AMT_ASSERT_DEF_DOMAIN(domain)					      \
namespace AMT {								      \
namespace Assert {							      \
namespace Domain {							      \
inline const char *domain() { return #domain; }				      \
}									      \
}									      \
}									      \
const char *AMT::Assert::Domain::domain()


AMT_ASSERT_DEF_DOMAIN(libamt_internal);

#ifdef AMT_NEED_ASSERTION_FOR_LIBAMT_INTERNAL
#define AMT_ASSERT_LIBAMT_I_(comm, cond)				      \
AMT_ASSERT_(libamt_internal, comm, cond, #cond)
#else
#define AMT_ASSERT_LIBAMT_I_(comm, cond)
#endif


AMT_ASSERT_DEF_DOMAIN(libamt_usage);

#ifdef AMT_NEED_ASSERTION_FOR_LIBAMT_USAGE
#define AMT_ASSERT_LIBAMT_U_(comm, cond)				      \
AMT_ASSERT_(libamt_usage, comm, cond, #cond)
#else
#define AMT_ASSERT_LIBAMT_U_(comm, cond)
#endif


#ifdef AMT_DEBUG
#define AMT_DEBUG_CODE(code) code
#else
#define AMT_DEBUG_CODE(code)
#endif

#endif
